'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                TheCube                                   |
'|                                                                          |
'|                         GDImage/OpenGL project                           |
'|                                                                          |
'|              3D cube animation to perform image selection.               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 06-18-2009 (MM-DD-YYYY)            |
'|                        Last revised : 06-20-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "TheCube.exe"
#OPTION VERSION5

'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
'DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

%VK_PRIOR                 = &H21
%VK_NEXT                  = &H22
%VK_END                   = &H23
%VK_HOME                  = &H24
%VK_LEFT                  = &H25
%VK_NUMPAD4               = &H64
%VK_UP                    = &H26
%VK_NUMPAD8               = &H68
%VK_RIGHT                 = &H27
%VK_NUMPAD6               = &H66
%VK_DOWN                  = &H28
%VK_NUMPAD2               = &H62

%SQUARE_MODE              = 2 ' 2 Texture stretching mode

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE              = 800 '// Window minimum width
%YMIN_SIZE              = 600 '// Window minimum height

%GL_SizeX               = 320 '// X size of the OpenGL object
%GL_SizeY               = 320 '// Y size of the OpenGL object
%TIMER_DELAY            = 80'40  '// Timer delay (animation speed)

%ID_BACKGROUND          = -999
%ID_CTRL                = -1

%IDS_CLONE2             = -4
%IDS_CLONE1             = -3
%IDS_GDIMAGE            = -2
%IDS_3DOBJECT           = 1

%ID_GDIMAGE             = -9
%ID_FRAMEBUTTON         = -10

%ID_BACK_LIST           = -36

%ID_BTN_ABOUT           = -37

%ID_LIB_BACK            = -44

%ID_BTN_HELP            = -46

%ID_GEM                 = -61

GLOBAL gnCtrl, gMainWnd AS DWORD
GLOBAL gnFocusID, gnMouseHit AS LONG
GLOBAL mt() AS ZGLTEXTUREX

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

'SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
'    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
'END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

FUNCTION GetSetGLmemDC(BYVAL hDC AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasDC AS LONG
    IF RW THEN WasDC = hDC
    FUNCTION = WasDC
END FUNCTION
FUNCTION GLmemDC() AS LONG
    FUNCTION = GetSetGLmemDC(0, 0)
END FUNCTION

'// This is the place where we create all the sprites being used into the GDImage control
FUNCTION GDImageCreateSprite() AS LONG
    LOCAL rc AS RECT
    LOCAL K, hMemDC, hList, nItem, nBitmap, nW, nH AS LONG

    CALL GetClientRect(gnCtrl, rc)

'   // Draw our watermark logo
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "GDImage.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, rc.nRight - nW, 0, nBitmap, ZD_ColorARGB(225, 0), %IDS_GDIMAGE, %ZS_VISIBLE)
    CALL ZD_SetObjectLocked(%IDS_GDIMAGE, %TRUE)
    CALL ZD_SetObjectAnchorMode(%IDS_GDIMAGE, %ANCHOR_RIGHT)

'   ///////////////////////////////////////
'   // Start of OpenGL section
'   // Create the OpenGL rendering context
    CALL GL_CreateContext(%GL_SizeX, %GL_SizeY)
'   // Create the initial OpenGL texture.
    DIM mt(1 TO 6) AS ZGLTEXTUREX

'   // Load texture from the hidden ListBox.
    hList = zGetMainItem(%ID_BACK_LIST)
    FOR K = 1 TO 6
        nItem = ListGetCursel(hList)
        IF nItem < ListCount(hList) THEN INCR nItem ELSE nItem = 1
        CALL ListSelectPlus(hList, nItem)
        mt(K).FullName = ListGetText(hList, nItem): mt(K).ID = K: mt(K).Square = %SQUARE_MODE
    NEXT

    CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

'   // Create the memory DIB DC to render the OpenGL sprite animation.
    hMemDC = GL_CreateDrawingDC(%GL_SizeX, %GL_SizeY)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (rc.nRight - %GL_SizeX) \ 2, (rc.nBottom - %GL_SizeY) \ 2, ZI_GetBitmapFromDC(hMemDC), ZD_ColorARGB(255, 0), %IDS_3DOBJECT, %ZS_VISIBLE)

    CALL ZD_SetObjectAnchorMode(%IDS_3DOBJECT, %ANCHOR_CENTER)
    CALL ZD_SetObjectScale(%IDS_3DOBJECT, 0.25)
'   // End of OpenGL section
'   ///////////////////////////////////////


'   // For the fun we add two clones
    CALL ZD_CloneObject(%IDS_3DOBJECT, %IDS_CLONE2, rc.nRight - %GL_SizeX, 0): ZD_SetObjectScale(%IDS_CLONE2, 0.5): ZD_SetObjectAnchorMode(%IDS_CLONE2, %ANCHOR_CENTER)
    CALL ZD_CloneObject(%IDS_3DOBJECT, %IDS_CLONE1, 0, 0): ZD_SetObjectAnchorMode(%IDS_CLONE1, %ANCHOR_CENTER)


'   // Make sure that the composited background is still at the bottom of z-order
    CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM)

'   // We put the GDImage focus on the %IDS_3DOBJECT
    CALL ZI_SetObjectFocusID(%IDS_3DOBJECT)
    gnFocusID = %IDS_3DOBJECT

'   // Turn on, high quality display
    CALL UpdateQualityStatus(%TRUE)

    IF hMemDC THEN
       CALL GetSetGLmemDC(hMemDC, 1)
       FUNCTION = hMemDC
    END IF

END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZIMAGE3D"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED '// Let the OS take care of the region for us (Doesn't work on XP)
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN


          IF (dwExStyle AND %WS_EX_LAYERED) THEN '// Warning this doesn't work on XP (only on VISTA and Windows 7)
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "TheCubeSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

          CALL GDImageEnableEvents(gnCtrl)
          CALL GDImageBackground()

'         // This is the place where we create all the sprites being used into the GDImage control
          IF GDImageCreateSprite() THEN '// If we have been sucessful, then play the show...

'            // *************************************************
'            // Show main window
'            // Create region and paint controls to double buffer
'            // *************************************************
             CALL zShowMainWindow(0)

             CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)

             WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
                IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                   CALL TranslateMessage(Msg)
                   CALL DispatchMessage(Msg)
                END IF
             WEND

             CALL KillTimer(gMainWnd, 1)

             '// VERY IMPORTANT
             '// FreeUp the resources
             IF GLmemDC() THEN
                CALL DeleteObject(ZI_GetBitmapFromDC( GLmemDC() ))
                CALL DeleteDC( GLmemDC() )
             END IF
             CALL GL_DeleteContext(GL_GLDC() , GL_GLRC() )

             FUNCTION = msg.wParam

          END IF
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the background listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%ID_BACK_LIST)
    CALL ListDeleteAll(hList)

    WashFind = MyFindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".gif.bmp.png.jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    CALL ListSelectPlus(hList, ListFindString(hList, zBackground))

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl AS LONG
    LOCAL sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH, imgW, imgH AS LONG, rw AS RECT

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 '%WS_EX_STATICEDGE
    gnCtrl = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           4, _                       ' initial x position
                           40, _                      ' initial y position
                           %XMIN_SIZE - (4 * 2), _    ' Calculate Window Width
                           %YMIN_SIZE - (40 + 4), _   ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl, %ANCHOR_HEIGHT_WIDTH)
    
'   ___________________

    'hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 594+8, 40, 191, 56, %ID_GDIMAGE, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    'hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Panel.png"), "", 1, 41, 135, 538, %ID_FRAMEBUTTON, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT)
    'CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    'hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 627+8, 102, 158, 395, %ID_FRAMEBUTTON, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_BOTTOM)

'   ___________________


'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %ID_BACK_LIST, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), zCXSYSICON(0,0), zCYSYSICON(0,0), %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    'hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", %XMIN_SIZE - (90 + 4), %YMIN_SIZE - 18, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    'CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    sImageName = SK_FOLDER() + "Gem.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    CALL GetWindowRect(gMainWnd, rw)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", ((rw.nRight - rw.nLeft) - imgW) \ 2, 0, imgW, imgH, %ID_Gem, 0)
    '//CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

END SUB

SUB GdimageResize()
    CALL GDImageBackground()
END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
'CALL KillTimer(hWnd, 1)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
'CALL SetTimer(hWnd, 1, 30, %NULL)
END SUB

SUB UpdateListBox(sUseFile AS STRING)
    LOCAL K, hList, hCtrl, WashFind, hFind, ImageCount, nSelected, DoIt, nItem, Img AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL sPath AS STRING

    hList = zGetMainItem(%ID_BACK_LIST)
    CALL ListDeleteAll(hList)

    sUseFile = zCharLower((sUseFile))
    CALL zSplitN(sUseFile, sPath, "")

    WashFind = MyFindFirstFile((sPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0

       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sPath + fd.cFileName: CALL CharLower(zTmp)
             DoIt = %FALSE
             IF RIGHT$(zTmp, 4) = ".jpg"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".png"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".bmp"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".gif"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".tif"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 5) = ".jpeg" THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 5) = ".tiff" THEN DoIt = %TRUE
CheckDone:
             IF DoIt THEN
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR ImageCount
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)

    LOOP
    CALL FindClose(WashFind)

    ListSelectPlus(hList, ListFindString(hList, (sUseFile)))

    IF ImageCount > 5 THEN
'       CALL ListSelectPlus(hList, 1)
       FOR K = 1 TO 6
           nItem = ListGetCursel(hList)
           IF nItem < ListCount(hList) THEN INCR nItem ELSE nItem = 1
           CALL ListSelectPlus(hList, nItem)
           mt(K).FullName = ListGetText(hList, nItem): mt(K).ID = K: mt(K).Square = %SQUARE_MODE
       NEXT

       CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

    END IF

    Img = zCreateImageFromFile((sUseFile))
    IF Img THEN
       CALL zDisposeImage(zGetProperty(gMainWnd, %FORM_Center))
       CALL zsCopyFile((sUseFile), (SK_CENTERFORM()))
       CALL zSetProperty(gMainWnd, %FORM_Center, Img)
       CALL ResizeWindow(gMainWnd, 1)
    END IF

END SUB

'// This is the magic place to control what is going on inside of the GDImage graphic container!
FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT, nRet, nObjectID, x, y, x1, y1, ObjectType, useWidth, useHeight, BoundWidth, BoundHeight, hDW AS LONG
    LOCAL x2Div2, y2Div2, useStep AS LONG
    LOCAL sDataString AS STRING

    STATIC LeftMouseClick AS LONG

    nRet = %FALSE ' Do not stop the event processing in GDImage

    nObjectID = ZI_MouseOverObjectID()

    SELECT CASE LONG Msg

    CASE %WM_LBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN

               LeftMouseClick = -1

               '//nSelected is int = ZD_GetObjectSelected(nObjectID)
               ObjectType = ZD_GetObjectType(nObjectID)
               IF (ObjectType = %OBJECT_BITMAP) OR (ObjectType = %OBJECT_TEXTBITMAP) THEN
                  IF gnFocusID <> nObjectID THEN
'//                     CALL GDImageChangeFocus(nObjectID)
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_LBUTTONUP
         IF nObjectID > 0 THEN

            IF LeftMouseClick THEN gnMouseHit = -1: LeftMouseClick = 0

            CALL UpdateQualityStatus(%TRUE)
         END IF

    CASE %WM_RBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN
              hDW = ZI_CreateDW(gMainWnd)
              'CALL ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_NEW_IMAGE)), zGetCTLText(zGetMainItem(%ID_BTN_Save)), "PhotoSetup")
              sDataString = ZI_LoadDialog(gMainWnd)
              CALL ZI_DestroyDW(hDW)
              IF LEN(sDataString) THEN
                 CALL UpdateListBox(sDataString)
              END IF
            END IF
         END IF

    CASE %WM_MOUSEMOVE
         IF nObjectID > 0 THEN
            IF ZI_IsLButtonDown() THEN

               IF LeftMouseClick THEN LeftMouseClick = 0

               CALL UpdateQualityStatus(%FALSE)
            ELSE
               IF ZI_IsShiftKeyPressed() = %FALSE THEN CALL UpdateQualityStatus(%TRUE)
            END IF
         END IF

    CASE %WM_KEYDOWN
         nObjectID = ZI_GetObjectFocusID() '// Move the sprite that has the focus
         IF nObjectID > 0 THEN

            IF ZI_IsAnyArrowPressed() THEN
               CALL UpdateQualityStatus(%FALSE)
            END IF

            CALL ZD_GetObjectXY(nObjectID, x, y)
            x1 = x ' Make a copy to keep the orignal x location unchanged
            y1 = y ' Make a copy to keep the orignal y location unchanged
          ' Check accelerator keys to compute the step range
            IF ZI_IsCtrlKeyPressed THEN
               UseStep = 4
               IF ZI_IsShiftKeyPressed THEN UseStep = 16
            ELSEIF ZI_IsShiftKeyPressed THEN
               UseStep = 2
            ELSE
               UseStep = 1
            END IF

            IF ZD_GetObjectScroll(nObjectID) THEN ' If object scroll with the bitmap background
             ' Get the size of the bitmap background
               CALL ZI_GetBitmapSize(ZI_GetBMP(hWnd), useWidth, useHeight)
            ELSE
             ' Get the control client size
               CALL GetClientRect(hWnd, lpr)
               useWidth = lpr.nRight: useHeight = lpr.nBottom
            END IF
          ' Get the sprite object size
            CALL ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)

            x2Div2 = (BoundWidth \ 2): y2Div2 = BoundHeight \ 2

            SELECT CASE wParam
            CASE %VK_HOME
                 x1 = 0
            CASE %VK_END
                 x1 = MAX&(useWidth - BoundWidth, 0)
            CASE %VK_PRIOR
                 y1 = 0
            CASE %VK_NEXT
                 y1 = MAX&(useHeight - BoundHeight, 0)
            CASE %VK_LEFT, %VK_NUMPAD4
                 IF x1 > -x2Div2 THEN x1 = MAX&(x1 - UseStep, -x2Div2)
            CASE %VK_UP, %VK_NUMPAD8
                 IF y1 > -y2Div2 THEN y1 = MAX&(y1 - UseStep, -y2Div2)
            CASE %VK_RIGHT, %VK_NUMPAD6
                 IF x1 < useWidth - x2Div2 THEN
                    x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                 END IF
            CASE %VK_DOWN, %VK_NUMPAD2
                 IF y1 < useHeight - y2Div2 THEN
                 y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                 END IF
            END SELECT

            IF x <> x1 OR y <> y1 THEN
               x = x1: y = y1
               CALL ZD_MoveLinkedObject(nObjectID, x1, y1, %TRUE)
            END IF
         END IF
    CASE %WM_KEYUP
         IF ZI_IsAnyArrowPressed() = 0 THEN
            CALL UpdateQualityStatus(%TRUE)
         END IF

    CASE %WM_SIZE
         CALL GDImageResize()

    CASE %WM_MOUSEWHEEL
         IF ZI_IsShiftKeyPressed THEN
            CALL UpdateQualityStatus(%FALSE)
         ELSE
            CALL UpdateQualityStatus(%TRUE)
         END IF
    END SELECT

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL hDC, hList, nItem, Img AS LONG

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_BTN_HELP, %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderAnimation(hWnd)

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageEnableEvents(BYVAL hGDImageCtrl AS LONG)
    LOCAL lpCallBack AS DWORD
    lpCallBack = CODEPTR(GDImageCallBack)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_NCHITTEST, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEWHEEL, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_SIZE, %TRUE)
END SUB

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG

    CALL GetWindowRect(zGetMainItem(%ID_CTRL), lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, %ZS_VISIBLE)
          CALL GdipDeleteGraphics(graphics)

          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the background is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)

END SUB

SUB UpdateQualityStatus(BYVAL bQuality AS LONG)
    LOCAL nInterpolation AS LONG
    IF bQuality THEN
       nInterpolation = 2 ' %InterpolationModeHighQuality
    ELSE
       nInterpolation = 0 ' %InterpolationModeDefault
    END IF
    IF ZD_GetObjectQuality(%IDS_3DOBJECT) <> nInterpolation THEN
       CALL ZD_SetObjectQuality(%IDS_3DOBJECT, nInterpolation, %TRUE)
    END IF
END SUB

DECLARE FUNCTION GetPixel LIB "GDI32.DLL" ALIAS "GetPixel" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS DWORD

'// This is the callback being used for all the animations
SUB RenderAnimation(BYVAL hWnd AS LONG)', BYVAL hGLDC AS LONG, BYVAL hGLRC AS LONG)
    LOCAL lp AS POINTAPI, rw AS RECT, x, y, mX, mY, HitDetection, Img, hList, nItem, nAlpha AS LONG
    LOCAL ID AS BYTE, rScale AS SINGLE
    STATIC Flip AS LONG

    '// Draw active frame to new memory DC
    'Flip = NOT Flip
    'IF Flip THEN

    IF ZD_IsObjectVisible(%IDS_GDIMAGE) THEN
       nAlpha = ZD_GetObjectAlpha(%IDS_GDIMAGE) - 2
       IF nAlpha > 0 THEN
          CALL ZD_SetObjectAlpha(%IDS_GDIMAGE, nAlpha, %FALSE)
       ELSE
          CALL ZD_SetObjectVisibility(%IDS_GDIMAGE, %FALSE)
       END IF
    END IF

    rScale = ZD_GetObjectScale(%IDS_3DOBJECT)
    IF rScale < 1 THEN
       rScale += .02: IF rScale > 1 THEN rScale = 1
       CALL ZD_SetObjectScale(%IDS_3DOBJECT, rScale)
    END IF

'       // Shall we perform a mouse hit detection
        HitDetection = gnMouseHit: gnMouseHit = 0 

'       // Draw the OpenGL object
        CALL DrawObject3D(GL_GLDC(), GL_GLRC(), HitDetection)
'       // Alphablend the OpenGL animation hover the background
        CALL GL_AlphaBlend( GLmemDC() , GL_GLDC() )

'       // Process the hit detection to change the background image
        IF HitDetection THEN
           CALL ZD_GetObjectXY(%IDS_3DOBJECT, x, y)
           CALL GetCursorPos(lp): CALL GetWindowRect(zGetMainItem(%ID_CTRL), rw)
           mX = lp.X - (rw.nLeft + x)
           mY = lp.Y - (rw.nTop + y)
           CALL zSplitColorARGB(GetPixel(GLmemDC(), mX, mY), 0, ID, 0, 0)
           Img = zCreateImageFromFile(mt(ID).FullName)
           IF Img THEN
              CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
              CALL zsCopyFile(mt(ID).FullName, (SK_CENTERFORM()))
              CALL zSetProperty(hWnd, %FORM_Center, Img)
              CALL ResizeWindow(hWnd, 1)

'             // What is the next ListBox texture to use?
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN INCR nItem ELSE nItem = 1
              CALL ListSelectPlus(hList, nItem)

'             // Update the selected texture
              mt(ID).FullName = ListGetText(hList, nItem)
              CALL ZI_UpdateNamedGLTextureFromFileEx(mt(ID).FullName, mt(ID).ID, mt(ID).Square)

           END IF
        ELSE
'          // Paint the resulting OpenGL bitmap to our window
           CALL ZD_ReplaceObjectBitmap(ZI_CreateBitmapFromImage(zBitmapToImage( GLmemDC() )), %IDS_3DOBJECT, %True)
        END IF

    'END IF

END SUB

%GL_BLEND                           = &H0BE2
%GL_TEXTURE_2D                      = &H0DE1
%GL_DEPTH_BUFFER_BIT                = &H00000100
%GL_COLOR_BUFFER_BIT                = &H00004000

DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL mask AS DWORD)
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity" ()
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glColor4ub LIB "opengl32.dll" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)

DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG

DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL cap AS DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL cap AS DWORD)

'//5.00
SUB DrawCube (BYVAL HitDetection AS LONG)
    IF HitDetection THEN CALL glColor4ub(0,0,1,255)
    CALL GL_DrawCubeFrontFace(mt(1).Texture)

    IF HitDetection THEN CALL glColor4ub(0,0,2,255)
    CALL GL_DrawCubeBackFace(mt(2).Texture)

    IF HitDetection THEN CALL glColor4ub(0,0,3,255)
    CALL GL_DrawCubeTopFace(mt(3).Texture)

    IF HitDetection THEN CALL glColor4ub(0,0,4,255)
    CALL GL_DrawCubeBottomFace(mt(4).Texture)

    IF HitDetection THEN CALL glColor4ub(0,0,5,255)
    CALL GL_DrawCubeRightFace(mt(5).Texture)

    IF HitDetection THEN CALL glColor4ub(0,0,6,255)
    CALL GL_DrawCubeLeftFace(mt(6).Texture)
END SUB

'// This is the place where we render the OpenGL object,
'// that will be displayed as the %IDS_3DOBJECT.
SUB DrawObject3D(BYVAL GLDC AS LONG, BYVAL GLRC AS LONG, BYVAL HitDetection AS LONG) ' See MSDN documentation for the use of the OpenGL API
    STATIC xrot AS SINGLE, yrot AS SINGLE, zrot AS SINGLE

    IF HitDetection = 0 THEN 
       xrot = (xrot + 2) mod 360 ' X Axis Rotation
       yrot = (yrot + 4) mod 360 ' Y Axis Rotation
       zrot = (zrot + 6) mod 360 ' Z Axis Rotation
    END IF

    '// Very important do not change: 0.015625 (it used to detect region)
    CALL glClearColor(0.015625, 0.0, 0.015625, 1.0) '// RGB(4,0,4) is our transparent color
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    CALL glLoadIdentity()
    CALL gluPerspective(38.0, 1.0, 1.0, 100.0)

    CALL glTranslatef(0.0, 0.0, -5.50)

    IF HitDetection THEN 
       CALL glDisable(%GL_TEXTURE_2D)
       CALL glDisable(&H0BE2) ' %GL_BLEND
    ELSE
       CALL glEnable(%GL_TEXTURE_2D)
       CALL glEnable(&H0BE2) ' %GL_BLEND
    END IF

    CALL glRotatef(xrot, 1.0, 0.0, 0.0)                             ' Rotate On The X Axis
    CALL glRotatef(yrot, 0.0, 1.0, 0.0)                             ' Rotate On The Y Axis
    CALL glRotatef(zrot, 0.0, 0.0, 1.0)                             ' Rotate On The Z Axis

    CALL glColor4ub(255,255,255,255)

    CALL DrawCube(HitDetection)

    CALL wglMakeCurrent(GLDC, GLRC)

END SUB
